#ifndef __MAIN_H__
#define __MAIN_H__

#include <QMainWindow>
#include <QPushButton>
#include <QComboBox>
#include <QLabel>
#include <QTimer>
#include <QCheckBox>
#include <QSlider>
#include <QString>
#include <QGroupBox>
#include <QBoxLayout>
#include <QVBoxLayout>
#include <QMenu>
#include <QMessageBox>
#include <explore.h>

class MainWindow : public QMainWindow
{
    Q_OBJECT
    ExplorecamDeviceV2  m_arr[EXPLORE_MAX];
    ExplorecamDeviceV2  m_cur;
    HExplorecam         m_hcam;
    QComboBox*       m_cmb_camera;
    QComboBox*       m_cmb_res;
    QCheckBox*       m_cbox_auto;
    QSlider*         m_slider_expoTime;
    QSlider*         m_slider_expoGain;
    QSlider*         m_slider_temp;
    QSlider*         m_slider_tint;
    QLabel*          m_lbl_expoTime;
    QLabel*          m_lbl_expoGain;
    QLabel*          m_lbl_temp;
    QLabel*          m_lbl_tint;
    QLabel*          m_lbl_video;
    QLabel*          m_lbl_frame;
    QPushButton*     m_btn_autoWB;
    QPushButton*     m_btn_open;
    QPushButton*     m_btn_snap;
    QTimer*          m_timer;
    unsigned         m_imgWidth;
    unsigned         m_imgHeight;
    uchar*           m_pData;
    int              m_res;
    double           m_fps;
    int              m_temp;
    int              m_tint;
    unsigned         m_count;
public:
    MainWindow(QWidget* parent = nullptr);
protected:
    void closeEvent(QCloseEvent*) override;
private:
    static void __stdcall eventCallBack(unsigned nEvent, void* pCallbackCtx);
    static QVBoxLayout* makeVLyt(QLabel*, QSlider*, QLabel*, QLabel*, QSlider*, QLabel*);
    void handleImageEvent();
    void handleExpoEvent();
    void handleTempTintEvent();
    void handleStillImageEvent();
    void closeCamera();
    void startCamera();
signals:
    void evtCallback(unsigned nEvent);
private slots:
    void onCameraChanged(int);
    void onResolutionChanged(int);
    void onBtnOpen();
    void onBtnSnap();
};

#endif
